#include <QtWidgets>
#include "file-editor.h"
#include "file-editor-tab.h"

file_editor::file_editor (QWidget *parent)
      : QDialog (parent)
{
    m_tab_widget = new QTabWidget;
    m_tab_widget->setTabsClosable (true);

    QVBoxLayout *mainLayout = new QVBoxLayout;
    mainLayout->addWidget (m_tab_widget);
    setLayout (mainLayout);

    connect (m_tab_widget, SIGNAL (tabCloseRequested (int)),
             this, SLOT (handle_tab_close_request (int)));
    connect (m_tab_widget, SIGNAL (currentChanged (int)),
             this, SLOT (active_tab_changed (int)));

    file_editor_tab *f1 = new file_editor_tab (tab1_txt);
    connect (this, SIGNAL (fetab_set_focus (const QWidget*)),
             f1, SLOT (set_focus (const QWidget*)));
    m_tab_widget->addTab (f1, QString ("TAB-1"));

    file_editor_tab *f2 = new file_editor_tab (tab2_txt);
    connect (this, SIGNAL (fetab_set_focus (const QWidget*)),
             f2, SLOT (set_focus (const QWidget*)));
    m_tab_widget->addTab (f2, QString ("TAB-2"));

    m_tab_widget->setCurrentWidget (f2);

    m_tab_widget->show ();
    emit fetab_set_focus (m_tab_widget->currentWidget ());

    resize (QDesktopWidget ().availableGeometry (this).size () * 0.33);
}

file_editor::~file_editor ()
{
    delete (m_tab_widget);
}

void file_editor::handle_tab_close_request (int i)
{
    m_tab_widget->removeTab (i);
    emit fetab_set_focus (m_tab_widget->currentWidget ());
}

void file_editor::active_tab_changed (int i)
{
    setFocusProxy (m_tab_widget->widget (i));
    emit fetab_set_focus (m_tab_widget->widget (i));
}

